definition module DynamicRefTools


::Tree= Node String [Tree] [String] //Node dynname refstootherdynamics typandcoderefs
	//this type represets a reference-tree built up from a dynamic

createRealDynamicFilenames :: [String] *World -> ([String],*World)
/*
	creates real dynamic filenames from a list of linkfilenames.
*/

readRefsFromDyn :: String [String] *World -> ([String],[String],[String],*World)
/*
	collects all the referenced files from a systemDynamic.
	gets: "C:\asd\asf\132114.. .dynsys", logMessages so far, world
	gives back: 1. (listOfReferencedDynamics(C:\asd\asf\534b.. .dynsys),
				2. listOfReferencedLybTyps(C:\asd\asf\123.. .lib; c:\asd\asf\123.. .lib)
				3. logMessages, 4. world
*/

readRefsFromBats :: [String] *World -> ([String],[String],*World)
/*
	gives back the referenced files by the ".bat"s. 
	(e.g. [c:\asd\asf\123.. .lib,c:\asd\asf\123.. .typ])
	gives back log messages for not dynamic applications.
	(should be changed when the name of the dynamic linker changes.)

*/

refTreeBuilder :: [String] *World -> ([Tree],[String],[String],*World)
/*  
  refTreeBuilder builts up the reference trees of the dynamics named in the
  first argument (these must be given in the String format of path). 
  It produces a Tuple4: (listOfReferenceTrees,touched dynamics,log messages,world).

*/

collectReferenced :: [Tree] -> [String]
/*
  Gives back all the filenames referenced by the tree. All referenced 
  filenames appear only once in this list.
*/
